//+------------------------------------------------------------------+
//|                                       Better Bollinger bands.mq4 |
//|                                                           mladen |
//|                                   mrtools added nrpma,alerts,mtf |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_chart_window
#property indicator_buffers 7
#property indicator_color1  None
#property indicator_color2  Blue
#property indicator_color3  Red
#property indicator_color4  tRed
#property indicator_color5  Blue
#property indicator_color6  Red
#property indicator_color7  None

//
//
//
//
//

extern int    BandsLength            = 13;
extern double BandsDeviation         = 2.0; 
extern int    BandsShift             = 0;
extern int    AppliedPrice           = PRICE_CLOSE;
extern bool   MultiColor             = true;
extern bool   alertsOn               = false;
extern bool   alertsOnUpperBandSlope = false;
extern bool   alertsOnLowerBandSlope = false;
extern bool   alertsOnCurrent        = false;
extern bool   alertsMessage          = false;
extern bool   alertsSound            = false;
extern bool   alertsNotify           = false;
extern bool   alertsEmail            = false;

//
//
//
//
//

double ma[];
double upBDa[];
double upBDb[];
double upBand[];
double dnBDa[];
double dnBDb[];
double dnBand[];
double slope1[];
double slope2[];
double tBuffer[][4];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,ma);
   SetIndexBuffer(1,upBand);
   SetIndexBuffer(2,upBDa);
   SetIndexBuffer(3,upBDb);
   SetIndexBuffer(4,dnBand);
   SetIndexBuffer(5,dnBDa);
   SetIndexBuffer(6,dnBDb);

    SetIndexShift(0,BandsShift); 
    SetIndexShift(1,BandsShift);
    SetIndexShift(2,BandsShift);
    SetIndexShift(3,BandsShift);
    SetIndexShift(4,BandsShift); 
    SetIndexShift(5,BandsShift);
    SetIndexShift(6,BandsShift);   
      
    IndicatorShortName("better bollinger bands ");    
   return(0);
}

//
//
//
//
//

int deinit() { return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

#define iMt1 0
#define iMt2 1
#define iUt1 2
#define iUt2 3

//
//
//
//
//

int start()
{
   int    counted_bars=IndicatorCounted();
   int    limit,i,r;

   if(counted_bars < 0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit=MathMin(Bars-1,Bars-counted_bars);
         if (ArrayRange(tBuffer,0) != Bars) ArrayResize(tBuffer,Bars);  
         if (ArrayRange(slope1,0)!=Bars)    ArrayResize(slope1,Bars);
         if (ArrayRange(slope2,0)!=Bars)    ArrayResize(slope2,Bars);        
         
   //
   //
   //
   //
   //

   double alpha =  2.0/(BandsLength+1.0);
   
       if (MultiColor && slope1[limit]==-1) CleanPoint(limit,upBDa,upBDb);  
       if (MultiColor && slope2[limit]==-1) CleanPoint(limit,dnBDa,dnBDb); 
       for (i=limit, r=Bars-i-1; i>=0; i--,r++)
       {
          double price = iMA(NULL,0,1,0,MODE_SMA,AppliedPrice,i);
         
          //
          //
          //
          //
          //
         
            tBuffer[r][iMt1] = tBuffer[r-1][iMt1] + alpha*(price           -tBuffer[r-1][iMt1]);
            tBuffer[r][iUt1] = tBuffer[r-1][iUt1] + alpha*(tBuffer[r][iMt1]-tBuffer[r-1][iUt1]);
               double dt  = ((2-alpha)*tBuffer[r][iMt1]-tBuffer[r][iUt1])/(1-alpha);
            
            tBuffer[r][iMt2] = tBuffer[r-1][iMt2] + alpha*(MathAbs(price-dt)-tBuffer[r-1][iMt2]);
            tBuffer[r][iUt2] = tBuffer[r-1][iUt2] + alpha*(tBuffer[r][iMt2] -tBuffer[r-1][iUt2]);
               double dt2 = ((2-alpha)*tBuffer[r][iMt2]-tBuffer[r][iUt2])/(1-alpha);

         //
         //
         //
         //
         //
         
         ma[i]     = dt;
         upBand[i] = dt+BandsDeviation*dt2;
         dnBand[i] = dt-BandsDeviation*dt2;
         upBDa[i]  = EMPTY_VALUE;
         upBDb[i]  = EMPTY_VALUE;
         dnBDa[i]  = EMPTY_VALUE;
         dnBDb[i]  = EMPTY_VALUE;
         slope1[r] = slope1[r-1];
         slope2[r] = slope2[r-1];

            if (upBand[i] < upBand[i+1]) slope1[r] =-2;
            if (upBand[i] > upBand[i+1]) slope1[r] = 2;
            if (dnBand[i] < dnBand[i+1]) slope2[r] =-2;
            if (dnBand[i] > dnBand[i+1]) slope2[r] = 2;
            if (MultiColor && slope1[r] == -1) PlotPoint(i,upBDa,upBDb,upBand);
            if (MultiColor && slope2[r] == -1) PlotPoint(i,dnBDa,dnBDb,dnBand);
               
      }
 manageAlerts();
 return(0);            
 }
   
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,0,whichBar)); 
                             whichBar = Bars-whichBar-1;

      //
      //
      //
      //
      //
            
      static datetime time1 = 0;
      static string   mess1 = "";
      if (alertsOnUpperBandSlope && slope1[whichBar] != slope1[whichBar-1])
      {
         if (slope1[whichBar] ==  1) doAlert(time1,mess1,whichBar,"Upper Band sloping up");
         if (slope1[whichBar] == -1) doAlert(time1,mess1,whichBar,"Upper Band sloping down");
      }
      
      static datetime time2 = 0;
      static string   mess2 = "";
      if (alertsOnLowerBandSlope && slope2[whichBar] != slope2[whichBar-1])
      {
         if (slope2[whichBar] ==  1) doAlert(time2,mess2,whichBar,"Lower Band sloping up");
         if (slope2[whichBar] == -1) doAlert(time2,mess2,whichBar,"Lower Band sloping down");
      }
      
   }
}

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, int forBar, string doWhat)
{
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Better Bollinger Bands ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsNotify)  SendNotification(StringConcatenate(Symbol(), Period() ," Better Bollinger Bands " +" "+message));
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Better Bollinger Bands "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}


